<template>
  <TLayout>
    <template #headerTitle>
      <HeaderNavbar />
    </template>
    <template #categories>
      <AsideCategories :categories="getSections" />
    </template>
    <template #cards>
      <MainSection />
    </template>
    <template #footer>
      <FooterSection />
    </template>
  </TLayout>
</template>

<script>
import { mapActions, mapGetters, mapMutations } from 'vuex';
import TLayout from '@/components/templates/TLayout';
import HeaderNavbar from '@/components/templates/HeaderNavbar';
import FooterSection from '@/components/templates/FooterSection';
import AsideCategories from '@/components/organisms/AsideCategories';
import MainSection from '@/components/templates/MainSection';

export default {
  name: 'HomeView',
  components: {
    TLayout,
    HeaderNavbar,
    AsideCategories,
    FooterSection,
    MainSection,
  },
  computed: {
    ...mapGetters(['getSections']),
  },
  methods: {
    ...mapMutations(['setWidth']),
    ...mapActions(['fillStore']),
    onResize({ target }) {
      this.setWidth(target.innerWidth);
    },
  },
  created() {
    this.fillStore();
    this.setWidth(window.innerWidth);
    window.addEventListener('resize', this.onResize);
  },
  beforeDestroy() {
    window.removeEventListener('resize', this.onResize);
  },
};
</script>
